<script lang="ts">
	import { run } from 'svelte/legacy';

	import { Map, View, Feature, Overlay, MapBrowserEvent } from 'ol'
	import TileLayer from 'ol/layer/Tile'
	import Polyline from 'ol/format/Polyline'
	import OSM from 'ol/source/OSM'
	import Style from 'ol/style/Style'
	import Stroke from 'ol/style/Stroke'
	import Icon from 'ol/style/Icon'
	import VectorLayer from 'ol/layer/Vector'
	import { fromLonLat } from 'ol/proj'
	import { Geometry, Point, LineString } from 'ol/geom'
	import VectorSource from 'ol/source/Vector'
	import { getLength } from 'ol/sphere'
	import { onDestroy, onMount } from 'svelte'
	import type { FeatureLike } from 'ol/Feature'
	import { tick } from 'svelte'

	interface Props {
		id?: string;
		journeyLengthKM?: number | undefined;
		journey?: string | undefined;
		meterDistance?: number | undefined;
		markerPng?: string;
		style: string | undefined;
		otherMeterDistances?: Array<{ name: string; distance: number; avatar: string; id: string }>;
		drawMarker?: boolean;
		overrideZoom?: number | null;
		debug?: boolean;
		disableUserZoom?: boolean;
	}

	let {
		id = 'map',
		journeyLengthKM = undefined,
		journey = undefined,
		meterDistance = undefined,
		markerPng = '//cdn.rawgit.com/openlayers/ol3/master/examples/data/icon.png',
		style,
		otherMeterDistances = [],
		drawMarker = true,
		overrideZoom = null,
		debug = false,
		disableUserZoom = false
	}: Props = $props();

	let tooltipElement: Element = $state()
	let tooltipName = $state('You')
	let tooltipDistance = $state('')
	let tooltipLeft = 'TIME LEFT'
	let tooltipTimeTaken = ''

	let map: Map | null = $state(null)
	let progressMarker: Feature<Geometry> | null = $state(null)
	let routeGeometry: Feature<Geometry> | null = $state(null)
	let mapLoaded = $state(false)
	let otherMarkers: Record<string, Feature<Geometry> | null> = {}



	function redrawOtherMarkers() {
		Object.values(otherMarkers)
			.filter((o) => !!o)
			.forEach((o) => vectorSource.removeFeature(o!))

		otherMeterDistances.forEach((o) => {
			const progressCoord = calcProgress(o.distance)
			otherMarkers[o.id] = addMarker(new Point(fromLonLat(progressCoord)), createImage(o.avatar), `${o.id}Marker`)
		})
	}

	// Keep a reference to the layer that we draw the route/markers onto
	const vectorSource = new VectorSource()
	const vectorLayer = new VectorLayer({ source: vectorSource })
	let overlay: Overlay | null = null

	// Taken straight from the stackexchange sample
	// Set up our styles to define how things look on the map
	const styles = {
		route: new Style({
			stroke: new Stroke({
				width: 6,
				color: [40, 40, 40, 0.8]
			})
		})
	}

	onMount(() => {
		overlay = new Overlay({ element: document.createElement('div'), stopEvent: false })
		map = new Map({
			target: id,
			layers: [
				new TileLayer({
					source: new OSM()
				}),
				vectorLayer
			],
			view: new View({
				center: fromLonLat([-1.4722, 53.4737]),
				zoom: overrideZoom || 6
			}),
			controls: [],
			overlays: [overlay],
			interactions: disableUserZoom? [] : undefined
		})

		mapLoaded = true

		if (!vectorLayer.getSource()) return
		map!.on('click', function (event) {
			var feature = map!.forEachFeatureAtPixel(event.pixel, function (feature) {
				return feature
			})
			const id = feature?.get('name')
			if (!feature || !id || !id.endsWith('Marker')) {
				return overlay?.setMap(null)
			}
			markerClick(feature, event)
		})
	})

	onDestroy(() => {
		if (!map) return
		map.setTarget(undefined)
		map = null
	})

	function markerClick(feature: FeatureLike, event: MapBrowserEvent<any>) {
		map!.getView().animate({ center: event.coordinate, duration: 200 }, async () => {
			map!.getView().setCenter(event.coordinate)
			if (!overlay) return
			const id = feature.get('name').replace('Marker', '')
			const data = otherMeterDistances.find((o) => o.id === id)
			const name = data?.name || 'You'
			const distanceKM = Math.round((data ? data.distance : meterDistance || 0) / 100) / 10

			tooltipName = name
			tooltipDistance = `Progress: ${distanceKM} km`

			// Create the HTML element for the overlay
			var content = tooltipElement //'<div class="here"><strong>' + name + '</strong><br><br><span>Progress: ' + distanceKM + ` km </span><br/><span>Left: ${journeyLengthKM - distanceKM} km</span></div>`
			var element = overlay.getElement()
			await tick()
			element!.innerHTML = content.outerHTML

			// Position the overlay above the clicked feature
			const coords = feature.getProperties().geometry.flatCoordinates.slice()
			overlay.setPosition(coords)

			// Show the overlay
			overlay.setMap(map)
		})
	}

	function createImage(markerPng: string) {
		return new Style({
			image: new Icon({
				src: markerPng,
				//size: [100, 100],
				offset: [0, 0],
				opacity: 1,
				height: 50
				//color: [10, 98, 240, 1]
			})
		})
	}

	function drawRoute(route: string, style?: Style) {
		routeGeometry = addRouteGeometry(
			new Polyline({
				factor: 1e5
			}).readGeometry(route, {
				dataProjection: 'EPSG:4326',
				featureProjection: 'EPSG:3857'
			}),
			style || styles.route
		)
	}

	// Adds a geometry to the current map
	function addRouteGeometry(geometry: Geometry, style: Style) {
		const feature = new Feature(geometry)
		feature.setStyle(style)
		vectorSource.addFeature(feature)
		feature.set('name', 'route')
		return feature
	}

	// Adds a marker/point/place to the current map
	function addMarker(point: Point, style: Style, name: string) {
		const feature = new Feature({ type: 'place', geometry: point })
		feature.setStyle(style)
		vectorSource.addFeature(feature)
		feature.set('name', name)
		return feature
	}

	function calcProgress(meterDistance: number) {
		const line = new Polyline({
			factor: 1e5
		}).readGeometry(journey, {
			dataProjection: 'EPSG:4326',
			featureProjection: 'EPSG:3857'
		})
		const lineDistance = Math.round(getLength(line) * 100) / 100
		const line2 = new Polyline({ factor: 1e5 }).readGeometry(journey) as LineString
		const percentDone = meterDistance ? meterDistance / lineDistance : 0
		return line2.getCoordinateAt(Math.min(percentDone, 1))
	}

	function saveMap() {
		if (!map) return
		map.once('rendercomplete', function () {
			const mapCanvas = document.createElement('canvas')
			const size = map!.getSize()
			mapCanvas.width = size![0]
			mapCanvas.height = size![1]
			const mapContext = mapCanvas.getContext('2d')
			Array.prototype.forEach.call(
				map!.getViewport().querySelectorAll('.ol-layer canvas, canvas.ol-layer'),
				function (canvas) {
					if (canvas.width > 0) {
						const opacity = canvas.parentNode.style.opacity || canvas.style.opacity
						mapContext!.globalAlpha = opacity === '' ? 1 : Number(opacity)
						let matrix
						const transform = canvas.style.transform
						if (transform) {
							// Get the transform parameters from the style's transform matrix
							matrix = transform
								.match(/^matrix\(([^\(]*)\)$/)[1]
								.split(',')
								.map(Number)
						} else {
							matrix = [
								parseFloat(canvas.style.width) / canvas.width,
								0,
								0,
								parseFloat(canvas.style.height) / canvas.height,
								0,
								0
							]
						}
						// Apply the transform to the export map context
						CanvasRenderingContext2D.prototype.setTransform.apply(mapContext, matrix)
						const backgroundColor = canvas.parentNode.style.backgroundColor
						if (backgroundColor) {
							mapContext!.fillStyle = backgroundColor
							mapContext!.fillRect(0, 0, canvas.width, canvas.height)
						}
						mapContext!.drawImage(canvas, 0, 0)
					}
				}
			)
			mapContext!.globalAlpha = 1
			mapContext!.setTransform(1, 0, 0, 1, 0, 0)
			const link = document.getElementById('image-download')
			link!.href = mapCanvas.toDataURL()
			link!.click()
		})
		map.renderSync()
	}
	run(() => {
		if (meterDistance && map && journey) {
			if (progressMarker) {
				vectorSource.removeFeature(progressMarker)
			}

			redrawOtherMarkers()

			const progressCoord = calcProgress(meterDistance)

			if (drawMarker) {
				progressMarker = addMarker(new Point(fromLonLat(progressCoord)), createImage(markerPng), 'userMarker')
			}

			map.getView().animate({ center: fromLonLat(progressCoord), zoom: overrideZoom || 12 }, () => {
				map!.getView().setCenter(fromLonLat(progressCoord))
			})
		}
	});
	run(() => {
		if (journey && mapLoaded) {
			if (routeGeometry) {
				vectorSource.removeFeature(routeGeometry)
			}
			drawRoute(journey)
		}
	});
</script>

<div class="map" {id} {style}></div>

<div style="display: hidden; position: fixed; top: -999px">
	<div class="here" id="tooltip" bind:this={tooltipElement}>
		<strong>{tooltipName}</strong>
		<span>{tooltipDistance}</span>
		<span>{tooltipLeft}</span>
	</div>
</div>

{#if debug}
	<div>
		<a onclick={saveMap} id="export-png" class="btn btn-outline-dark" role="button"
			><i class="fa fa-download"></i> Download PNG</a
		>
		<a id="image-download" download="map.png"></a>
	</div>
{/if}

<style>
	.map {
		height: 100%;
		width: 100%;
	}

	span {
		display: block;
	}

	:global(.here) {
		background-color: #ffffffaa;
		border: 1px solid #ccc;
		padding: 10px;
		border-radius: 5px;
		user-select: none;
	}
</style>
